Package ghidra.util

# Class MonitoredInputStream

java.lang.Object
java.io.InputStream
ghidra.util.MonitoredInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class MonitoredInputStream extends InputStream
An InputStream which utilizes a TaskMonitor to indicate input progress and allows the operation to be cancelled via the TaskMonitor. If monitor is cancelled any susequent read will generate a `IOCancelledException`.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected InputStream`
  `in`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MonitoredInputStream(InputStream in, TaskMonitor monitor)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Returns the number of bytes that can be read from this input stream without blocking.
  `boolean`
  `cleanupOnCancel()`
  Determine if artifact cleanup is recommended when possible following cancellation of this input stream (i.e., `IOCancelledException` has been caught).
  `void`
  `close()`
  Closes this input stream and releases any system resources associated with the stream.
  `TaskMonitor`
  `getTaskMonitor()`
  Get task monitor associated within this input stream.
  `void`
  `mark(int readlimit)`
  Marks the current position in this input stream.
  `boolean`
  `markSupported()`
  Tests if this input stream supports the `mark` and `reset` methods.
  `int`
  `read()`
  Reads the next byte of data from this input stream.
  `int`
  `read(byte[] b)`
  Reads up to `byte.length` bytes of data from this input stream into an array of bytes.
  `int`
  `read(byte[] b, int off, int len)`
  Reads up to `len` bytes of data from this input stream into an array of bytes.
  `void`
  `reset()`
  Repositions this stream to the position at the time the `mark` method was last called on this input stream.
  `MonitoredInputStream`
  `setCleanupOnCancel(boolean enable)`
  Convey to byte stream consumer if cleanup of any artifacts produced is recommended, when applicable, if `IOCancelledException` is thrown by this input stream.
  `void`
  `setProgress(long progress)`
  Reset the current progress count to the specified value.
  `long`
  `skip(long n)`
  Skips over and discards `n` bytes of data from the input stream.

  ### Methods inherited from class java.io.InputStream

  `nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### in

    protected InputStream in

- ## Constructor Details

  - ### MonitoredInputStream

    public MonitoredInputStream(InputStream in, TaskMonitor monitor)

- ## Method Details

  - ### getTaskMonitor

    public TaskMonitor getTaskMonitor()
    Get task monitor associated within this input stream.
    Returns:
      task monitor

  - ### setProgress

    public void setProgress(long progress)
    Reset the current progress count to the specified value.
    Parameters:
      `progress` - current progress

  - ### read

    public int read() throws IOException
    Reads the next byte of data from this input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

    This method simply performs `in.read()` and returns the result.

    Specified by:
      `read` in class `InputStream`
    Returns:
      the next byte of data, or `-1` if the end of the stream is reached.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### read

    public int read(byte[] b) throws IOException
    Reads up to `byte.length` bytes of data from this input stream into an array of bytes. This method blocks until some input is available.

    This method simply performs the call `read(b, 0, b.length)` and returns the result. It is important that it does not do `in.read(b)` instead; certain subclasses of `FilterInputStream` depend on the implementation strategy actually used.

    Overrides:
      `read` in class `InputStream`
    Parameters:
      `b` - the buffer into which the data is read.
    Returns:
      the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterInputStream.read(byte[], int, int)`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Reads up to `len` bytes of data from this input stream into an array of bytes. This method blocks until some input is available.

    This method simply performs `in.read(b, off, len)` and returns the result.

    Overrides:
      `read` in class `InputStream`
    Parameters:
      `b` - the buffer into which the data is read.
      `off` - the start offset of the data.
      `len` - the maximum number of bytes read.
    Returns:
      the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### skip

    public long skip(long n) throws IOException
    Skips over and discards `n` bytes of data from the input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. The actual number of bytes skipped is returned.

    This method simply performs `in.skip(n)`.

    Overrides:
      `skip` in class `InputStream`
    Parameters:
      `n` - the number of bytes to be skipped.
    Returns:
      the actual number of bytes skipped.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### available

    public int available() throws IOException
    Returns the number of bytes that can be read from this input stream without blocking.

    This method simply performs `in.available()` and returns the result.

    Overrides:
      `available` in class `InputStream`
    Returns:
      the number of bytes that can be read from the input stream without blocking.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### close

    public void close() throws IOException
    Closes this input stream and releases any system resources associated with the stream. This method simply performs `in.close()`.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `InputStream`
    Throws:
      `IOException` - if an I/O error occurs.

  - ### mark

    public void mark(int readlimit)
    Marks the current position in this input stream. A subsequent call to the `reset` method repositions this stream at the last marked position so that subsequent reads re-read the same bytes.

    The `readlimit` argument tells this input stream to allow that many bytes to be read before the mark position gets invalidated.

    This method simply performs `in.mark(readlimit)`.

    Overrides:
      `mark` in class `InputStream`
    Parameters:
      `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.
    See Also:
      - `FilterInputStream.reset()`

  - ### reset

    public void reset() throws IOException
    Repositions this stream to the position at the time the `mark` method was last called on this input stream.

    This method simply performs `in.reset()`.

    Stream marks are intended to be used in situations where you need to read ahead a little to see what's in the stream. Often this is most easily done by invoking some general parser. If the stream is of the type handled by the parse, it just chugs along happily. If the stream is not of that type, the parser should toss an exception when it fails. If this happens within readlimit bytes, it allows the outer code to reset the stream and try another parser.

    Overrides:
      `reset` in class `InputStream`
    Throws:
      `IOException` - if the stream has not been marked or if the mark has been invalidated.
    See Also:
      - `FilterInputStream.mark(int)`

  - ### markSupported

    public boolean markSupported()
    Tests if this input stream supports the `mark` and `reset` methods. This method simply performs `in.markSupported()`.
    Overrides:
      `markSupported` in class `InputStream`
    Returns:
      `true` if this stream type supports the `mark` and `reset` method; `false` otherwise.
    See Also:
      - `InputStream.mark(int)`
      - `InputStream.reset()`

  - ### setCleanupOnCancel

    public MonitoredInputStream setCleanupOnCancel(boolean enable)
    Convey to byte stream consumer if cleanup of any artifacts produced is recommended, when applicable, if `IOCancelledException` is thrown by this input stream.
    Parameters:
      `enable` - true if cleanup recommended, false if no cleanup neccessary (default).
    Returns:
      this instance

  - ### cleanupOnCancel

    public boolean cleanupOnCancel()
    Determine if artifact cleanup is recommended when possible following cancellation of this input stream (i.e., `IOCancelledException` has been caught).
    Returns:
      true if cleanup recommended, false if no cleanup required.